ScrollableView subclass:#SubCanvas
	instanceVariableNames:'client spec application'
	classVariableNames:''
	poolDictionaries:''
	category:'Views-Basic'
!


!SubCanvas methodsFor:'accessing'!

releaseAllComponents
    scrolledView destroySubViews.
! !

!SubCanvas methodsFor:'initialization'!

initialize
    super initialize.
    self scrolledView:View new
! !

!SubCanvas methodsFor:'queries'!

application
    "return the application, under which this view was opened,
    "

    application notNil ifTrue:[
        ^ application
    ].
    ^ super application

    "Modified: 13.1.1997 / 20:30:31 / cg"


! !

!SubCanvas methodsFor:'rebuilding'!

client:anApplicationModel
    "release existing components and generate new components from
     the applications windowSpec."

    ^ self client:anApplicationModel spec:#windowSpec
!

client:anApplicationModel spec:aWindowSpec
    "release existing components and generate new components from
     the applications windowSpec."

    |b newBuilder|

    "/ If the application already has a builder, create a subBilder;
    "/ otherwise a new one

    ((anApplicationModel respondsTo:#builder)
      and:[(b := anApplicationModel builder) notNil]) ifTrue:[
          newBuilder := b. "/ newSubBuilder
    ] ifFalse:[
        newBuilder := UIBuilder new
    ].
    ^ self client:anApplicationModel spec:aWindowSpec builder:newBuilder

    "Created: 6.3.1997 / 15:53:25 / cg"
    "Modified: 6.3.1997 / 15:59:44 / cg"
!

client:anApplicationModel spec:aWindowSpecOrSpecSymbol builder:aBuilder
    "release existing components and generate new components from
     the given windowSpec, using the given builder."

    |spec |

    scrolledView notNil ifTrue:[
        scrolledView destroySubViews
    ].

    spec := aWindowSpecOrSpecSymbol.

    application := anApplicationModel.

    spec isSymbol ifTrue:[
        anApplicationModel isNil ifTrue:[
            spec := nil
        ] ifFalse:[
            spec := anApplicationModel class interfaceSpecFor:spec
        ]
    ].

    spec notNil ifTrue:[
        aBuilder buildFromSpec:spec in:scrolledView.
    ].
    self realized ifTrue:[
        scrolledView realizeAllSubViews
    ].
    ^ aBuilder
! !

!SubCanvas class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libwidg2/SubCanvas.st,v 1.1 1997-07-04 21:17:46 cg Exp $'
! !
